# Autogenerated wrapper script for Pixman_jll for x86_64-unknown-freebsd11.1
export libpixman

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libpixman`
const libpixman_splitpath = ["lib", "libpixman-1.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libpixman_path = ""

# libpixman-specific global declaration
# This will be filled out by __init__()
libpixman_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libpixman = "libpixman-1.so.0"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"Pixman")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    global libpixman_path = normpath(joinpath(artifact_dir, libpixman_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libpixman_handle = dlopen(libpixman_path)
    push!(LIBPATH_list, dirname(libpixman_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

